/*
 * Copyright 2006 Maskat Project.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.maskat.framework;

import java.util.Iterator;

/**
 * 定義XMLファイルの要素オブジェクトに対して<br>
 * 子要素のiteratorとして使われる。<br>
 * 子要素の削除とともに、BasicDefのchildrenから子要素を削除
 * 
 * @author shengshen
 * 
 */
public class DefChildIterator implements Iterator {

	IBasicDef basicDef;

	Iterator it;

	Object current = null;

	/** カレントエレメントはremoveされたかフラグ */
	boolean removed = false;

	public DefChildIterator(IBasicDef basicDef, Iterator it) {
		this.basicDef = basicDef;
		this.it = it;
	}

	public void remove() {
		if (removed == true) {
			return;
		}
		basicDef.removeChild(current);
		it.remove();
		current = null;
		removed = true;
	}

	public boolean hasNext() {
		return it.hasNext();
	}

	public Object next() {
		current = it.next();
		removed = false;
		return current;
	}

}
